#![cfg(target_arch = "x86_64")]
pub const TIMER_FREQUENCY: u64 = 5000;
const BASE_FREQUENCY: u32 = 1193182;

use x86_64::instructions::port::Port;
use crate::arch::io;

pub fn platform_init()
{
    let mut divisor = (BASE_FREQUENCY / TIMER_FREQUENCY as u32) as u16;
    if divisor < 100 { divisor = 100; }

    let mut port: Port<u8> = Port::new(0x40);

    unsafe { 
        port.write((divisor & 0xff) as u8);
        io::io_delay();
        port.write(((divisor & 0xFF00) >> 8) as u8);
    }
}

pub fn frequency() -> u64 {
    return TIMER_FREQUENCY;
}